<?php

/*
	Hide Folder v2.2
	Originally created by Taurnil
	Written in PHP by keaglez/Jeffri Hong
	show* binaries by arctu/Faruq
*/

define("MYPATH", dirname($_SERVER['PHP_SELF']));
define("TITLE", "Hide Folder");
define("ICON", MYPATH."/hidefolder.png");
$config_files = MYPATH."/configs.php";
$lang_folder = MYPATH;
require("show.php");
require("kgapps.php");

if (`whoami` != "root\n")
{
	// chech whether run as root or not, if not, we die here
	$error = new showNotify("Error", "Not run as root, exit.", 1);
	$error->exec();
	die("Error, not run as root.\n");
}

// here is a class for managing folder
class folder_manager
{
	public $current_dir = '/';
	public function __construct($parent_dir)
	{
		if (is_dir($parent_dir))
		{
			$this->current_dir = $parent_dir;
		}
	}
	public function list_dir($restricted_dir)
	{
		$restrict = explode("|", $restricted_dir);
		$read_dir = scandir($this->current_dir);
		$i = 0;
		foreach ($read_dir as $folder)
		{
			$rest = 0;
			if ($folder == '.' || $folder == '..')
				continue; // we won't display this folder
			$full_dir = $this->current_dir.'/'.$folder;
			if (! is_dir($full_dir))
				continue; // we display only folder...so exclude files
			foreach ($restrict as $x)
			{
				if ($full_dir == $x)
					$rest = 1; // it is restricted directory
			}
			if ($rest == 1)
				continue; // we won't display it either
			$i++;
			$out[$i] = $folder;
		}
		if (! isset($out))
			return false;
		return $out;
	}
	public function get_current_dir()
	{
		return $this->current_dir;
	}
	public function change_dir($new_dir)
	{
		// change current directory, so it will work for sub directory too
		if (empty($new_dir))
			return false;
		if (! is_dir($new_dir))
		{
			if (! is_dir($this->current_dir.'/'.$new_dir))
				return false;
			else
				$this->current_dir = $this->current_dir.'/'.$new_dir;
		}
		else
		{
			$this->current_dir = $new_dir;
		}
		return true;
	}
	public function hide_dir($dir)
	{
		if (is_dir($dir))
		{
			$folder_name = basename($dir);
		}
		elseif (is_dir($this->current_dir.'/'.$dir))
		{
			$folder_name = $dir;
		}
		else
		{
			return false;
		}
		if (ereg("^\.", $folder_name))
		{
			return false;
		}
		else
		{
			rename($this->current_dir.'/'.$folder_name, $this->current_dir.'/.'.$folder_name);
			return true;
		}
	}
	public function show_dir($dir)
	{
		if (is_dir($dir))
		{
			$folder_name = basename($dir);
		}
		elseif (is_dir($this->current_dir.'/'.$dir))
		{
			$folder_name = $dir;
		}
		else
		{
			return false;
		}
		if (ereg("^\.", $folder_name))
		{
			rename($this->current_dir.'/'.$folder_name, $this->current_dir.'/'.ereg_replace("^\.", "", $folder_name));
			return true;
		}
		else
		{
			return false;
		}
	}
}

class settings extends config
{
	public function __construct($cfg)
	{
		config::__construct($cfg);
	}
	public function security_mode()
	{
		global $security, $str, $interface, $password;
		switch ($security)
		{
			case 0:
				$cur_str = $str[20];
				break;
			case 1:
				$cur_str = $str[21];
				break;
			case 2:
				$cur_str = $str[22];
				break;
		}
		$interface['security']->set_list("'".$str[20]."' '".$str[21]."' '".$str[22]."'");
		$interface['security']->set_context($str[1]."\n".sprintf($str[23], $cur_str));
		$ret = $interface['security']->exec();
		if ($ret[1] != 0)
		{
			if ($password == "" && $ret[1] > 1)
			{
				$interface['confirm']->set_context($str[26]);
				$ret2 = $interface['confirm']->exec();
				if ($ret2 == 1)
				{
					$this->set_password(1);
				}
				else
				{
					return false;
				}
			}
			$this->set("security", $ret[1] - 1);
		}
	}
	public function set_password($mode)
	{
		global $interface, $str, $password;
		// mode 1 == set new password, mode 2 == change password
		if ($mode == 2)
		{
			if (check_password() == false)
				return false;
		}
		$interface['password']->set_context($str[19]);
		$ret1 = $interface['password']->exec();
		if ($ret1[1] == 0)
			return;
		$interface['password']->set_context($str[24]);
		$ret2 = $interface['password']->exec();
		if ($ret2[1] == 0)
			return;
		if ($ret1[0] == $ret2[0])
		{
			$new_pass = md5($ret1[0]);
			$this->set("password", $new_pass);
		}
		else
		{
			$interface['error']->set_context($str[25]);
			$interface['error']->exec();
		}
	}
}

function check_password()
{
	global $interface, $str, $password;
	$interface['password']->set_context($str[18]);
	$ok = 0;
	while ($ok != 1)
	{
		$ret = $interface['password']->exec();
		if ($ret[1] == 1)
		{
			$check = md5($ret[0]);
			if ($password == $check)
			{
				$ok == 1;
				return true;
			}
			else
			{
				$interface['error']->set_context($str[25]);
				$interface['error']->exec();
			}
		}
		else
		{
			return false;
		}
	}
}

// default configuration
$password = "";
$security = 0;
$language = "en.lang.php";
$parent_dir = "/mmc/mmca1";
$restricted = "/mmc/mmca1/.system|/ezxlocal/.system|/ezx_user/sysDatabase|/ezxlocal/sysDatabase|/ezxlocal/download/appwrite|/ezx_user/download/appwrite|/ezxlocal/download/java|/ezxlocal/download/mystuff";

require($lang_folder."/".$language);

// set all show* instance
$interface['main'] = new showList(TITLE);
$interface['confirm'] = new showQ($str[12], $str[12], 1);
$interface['error'] = new showNotify($str[11], $str[11], 2);
$interface['help'] = new showQ($str[8], $help_text, 2);
$interface['about'] = new showQ($str[9], $about_text, 2);
$interface['security'] = new showList(TITLE);
$interface['password'] = new showEntry(TITLE, null, 1);

foreach	($interface as $index)
{
	$index->set_icon(ICON); // set icon for all instance
}

$done = 0;
$ok = 0;

// start here...
while ($done != 1)
{
	if (! file_exists($config_files))
	{
		if ($opn = fopen($config_files, "w"))
		{
			$text =
				"<?php\n" .
				"\$password = \"$password\";\n" .
				"\$security = $security;\n" .
				"\$language = \"$language\";\n" .
				"\$parent_dir = \"$parent_dir\";\n" .
				"\$restricted = \"$restricted\";\n" .
				"?>\n";
			fwrite($opn, $text);
			fclose($opn);
		}
		$configs = new settings($config_files);
		$interface['confirm']->set_context($str[1]);
		$ret = $interface['confirm']->exec();
		if ($ret == 1)
		{
			$configs->set_password(1);
		}
	}
	if (! isset($configs))
		$configs = new settings($config_files);
	if (! isset($manager))
		$manager = new folder_manager($parent_dir);
	include($config_files);
	
	if ($security > 0 && $ok == 0)
	{
		if (check_password() == false)
		{
			break;
		}
		else
		{
			$ok = 1;
		}
	}
	
	$lists_arr = $manager->list_dir($restricted);
	if ($lists_arr != false)
		$lists = "'" . implode("' '", $lists_arr) . "'";
	else
		$lists = "";
	$interface['main']->set_list($lists);
	
	if ($password != "")
	{
		$pass_str = $str[6];
		$pass_mode = 2;
	}
	else
	{
		$pass_str = $str[7];
		$pass_mode = 1;
	}
	$cur_dir = $manager->get_current_dir();
	if ($cur_dir == $parent_dir)
	{
		$rsk_str = $str[16];
	}
	else
	{
		$rsk_str = $str[17];
	}
	
	$interface['main']->set_option("'".$str[2]."' 'open' '".$str[3]."' 'hide' '".$str[4]."' 'show' '".$str[5]."' 'security' '".$pass_str."' 'pass' '".$str[8]."' 'help' '".$str[9]."' 'about' '".$str[16]."' 'exit'");
	$interface['main']->set_context(sprintf($str[10], $cur_dir));
	$interface['main']->set_rsk($rsk_str);
	
	$ret = $interface['main']->exec();
	$main = $ret[1];
	$option = $ret[0];
	
	$chosen_folder = $lists_arr[$main];

	switch ($option)
	{
		case "Cancel!":
			if ($cur_dir == $parent_dir)
			{
				$done = 1;
			}
			else
			{
				if ($manager->change_dir(dirname($cur_dir)) == false)
				{
					$interface['error']->set_context(sprintf($str[15], dirname($cur_dir)));
					$interface['error']->exec();
				}
			}
			break;
		case "exit":
			$done = 1;
			break;
		case "hide":
			if ($security == 2)
			{
				if (check_password() == false)
				{
					break;
				}
			}
			if ($manager->hide_dir($chosen_folder) == false)
			{
				$interface['error']->set_context(sprintf($str[13], $cur_dir.'/'.$chosen_folder));
				$interface['error']->exec();
			}
			break;
		case "show":
			if ($security == 2)
			{
				if (check_password() == false)
				{
					break;
				}
			}
			if ($manager->show_dir($chosen_folder) == false)
			{
				$interface['error']->set_context(sprintf($str[14], $cur_dir.'/'.$chosen_folder));
				$interface['error']->exec();
			}
			break;
		case "security":
			$configs->security_mode();
			break;
		case "pass":
			$configs->set_password($pass_mode);
			break;
		case "help":
			$interface['help']->exec();
			break;
		case "about":
			$interface['about']->exec();
			break;
		case "open":
		default:
			if (ereg("^\.", $chosen_folder))
			{
				if ($security == 2)
				{
					if (check_password() == false)
						break;
				}
			}
			if ($manager->change_dir($chosen_folder) == false)
			{
				$interface['error']->set_context(sprintf($str[15], $cur_dir.'/'.$chosen_folder));
				$interface['error']->exec();
			}
			break;
	}
}

exit(0);


 ?>